// ConfigView.cpp - Implementation for the ConfigView class
// Provides controls for our screensaver


#include "ConfigView.h"


// Constructor
ConfigView::ConfigView(BRect frame, const char *name, bool* new_DrawBackground, bool *new_boolWaitForRetrace)
 : BView(frame, name, 0, B_FOLLOW_ALL), DrawBackground(new_DrawBackground), 
 	boolWaitForRetrace(new_boolWaitForRetrace)
{
  // Nothing to do here...
}
    
    
// AttachedToWindow() gets called when the view is attached to a parent
//  window, which is a good time to set up our menu widgets
void ConfigView::AttachedToWindow()
{
  	// Make our background color match the one used by the screensaver
  	//  configuration panel
  	SetViewColor(ui_color(B_PANEL_BACKGROUND_COLOR));
	
	//Title
  	lblTitle = new BStringView(BRect(8, 0, 200, 60), "lblTitle", "BeWake");
	lblTitle->SetFontSize(48);
	this->AddChild(lblTitle);
	//About Label
	lblAbout = new BStringView(BRect(10, 65, 200, 75), "lblAbout", "2003 M477 Design");
	this->AddChild(lblAbout);
	//Author Label
	lblBy = new BStringView(BRect(10, 77, 200, 87), "lblBy", "by Mattia Tristo");
	this->AddChild(lblBy);
	//EMail Label
	lblEMail = new BStringView(BRect(10,89,200,99),"lblEMail","EMail : mattia_tristo@libero.it");
	this->AddChild(lblEMail);
	//Transparent Background CheckBox
	chkBackground = new BCheckBox(BRect(10,121,200,131),"chkBackground","Transparent Background", new BMessage('cbtb'), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
    if(*DrawBackground)
    {
    	chkBackground->SetValue(B_CONTROL_OFF);
  	}
  	else
  	{
    	chkBackground->SetValue(B_CONTROL_ON);
  	}
  	this->AddChild(chkBackground);
  	chkBackground->SetTarget(this);
  	//WaitForRetrace CheckBox
  	chkUseWaitForRetrace = new BCheckBox(BRect(10,138,200,148),"chkUseWaitForRetrace","Use WaitForRetrace", new BMessage('cbwr'), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
    if(*boolWaitForRetrace)
    {
    	chkUseWaitForRetrace->SetValue(B_CONTROL_ON);
  	}
  	else
  	{
    	chkUseWaitForRetrace->SetValue(B_CONTROL_OFF);
  	}
  	this->AddChild(chkUseWaitForRetrace);
  	chkUseWaitForRetrace->SetTarget(this);
	
}


// Handle messages to checkboxes, and update our configuration variables with
//  the current values of the checkboxes
void ConfigView::MessageReceived(BMessage *msg)
{
  switch(msg->what)
  {
  	/*
    case 'cvs0':
      *num_sparks = (int) (num_sparks_slider->Position() * MAX_SPARKS);
      // Needed because of a slight rounding error
      if(*num_sparks < MIN_SPARKS)
      {
        *num_sparks = MIN_SPARKS;
      }
      if(*num_sparks > MAX_SPARKS)
      {
        *num_sparks = MAX_SPARKS;
      }
      break;

    case 'cvs1':
      *trail_length = (int) (trail_length_slider->Position() * MAX_TRAIL_LENGTH);
      // Needed because of a slight rounding error
      if(*trail_length < MIN_TRAIL_LENGTH)
      {
        *trail_length = MIN_TRAIL_LENGTH;
      }
      if(*trail_length > MAX_TRAIL_LENGTH)
      {
        *trail_length = MAX_TRAIL_LENGTH;
      }
      break;

    case 'cvs2':
      // We actually divide this in half, the negative side devoted to repulsion and the
      //  positive side to attraction
      *gravity = (gravity_slider->Position() - 0.5);
      
      // Needed because of a slight rounding error when slider position = 1.0
      if(*gravity > 0.49)
      {
        *gravity = 0.49;
      }
      
      if(*gravity < 0)
      {
        *gravity = (*gravity * 2.0) * fabs(MIN_GRAVITY);
      }
      else
      {
        *gravity = (*gravity * 2.0) * fabs(MAX_GRAVITY);
      }
      break;
	*/
	
    case 'cbtb':
      if(chkBackground->Value() == B_CONTROL_ON)
      {
        *DrawBackground = false;
      }
      else
      {
        *DrawBackground = true;
      }      
      break;
      
      case 'cbwr':
      if(chkUseWaitForRetrace->Value() == B_CONTROL_ON)
      {
        *boolWaitForRetrace = true;
      }
      else
      {
        *boolWaitForRetrace = false;
      }      
      break;
      
    default:
      break;
  }

  // Respond that we have handled the message that came in (whatever it was)
  //  so that it'll be removed from the message queue
  BView::MessageReceived(msg);
}


